;; -*- Mode:emacs-lisp -*-
;; sawzilla/theme.jl
;; looks like the Mozilla M13 default theme.

(let*
		(
		 (font-colors (list "gray30"
												"cyan"))
    
		 (close-image (list (make-image "closelinedbutton2.png")
												(make-image "closelinedbutton.png")
												(make-image "closeplainbutton.png")
												(make-image "closeplainbutton.png")))
		 (max-image (list (make-image "maxlinedbutton2.png")
											(make-image "maxlinedbutton.png")
											(make-image "maxplainbutton.png")
											(make-image "maxplainbutton.png")))
		 (min-image (list (make-image "minlinedbutton2.png")
											(make-image "minlinedbutton.png")
											(make-image "minplainbutton.png")
											(make-image "minplainbutton.png")))
		 (menu-image (list (make-image "menulinedbutton2.png")
											 (make-image "menulinedbutton.png")
											 (make-image "menuplainbutton.png")
											 (make-image "menuplainbutton.png")))
		 (title-image (list (make-image "titlebar2.png")
												(make-image "titlebar.png")))
		 (top-image (list (make-image "topedge2.png")
											(make-image "topedge.png")))
		 (top-left-image (list (make-image "topleftcorner2.png")
													 (make-image "topleftcorner.png")))
		 (top-right-image (list (make-image "toprightcorner2.png")
														(make-image "toprightcorner.png")))
		 (bottom-left-image (list (make-image "bottomleftcorner2.png")
															(make-image "bottomleftcorner.png")))
		 (bottom-right-image (list (make-image "bottomrightcorner2.png")
															 (make-image "bottomrightcorner.png")))
		 (bottom-image (list (make-image "bottomedge2.png")
												 (make-image "bottomedge.png")))
		 (left-side-image (list (make-image "leftedge2.png")
														(make-image "leftedge.png")))
		 (right-side-image (list (make-image "rightedge2.png")
														 (make-image "rightedge.png")))
		
		 (title-alignment (lambda () center))
		 (button-top-offset (lambda () -22))
		 (button-side-offset (lambda () 3))

		 (frame `(
							(
							 (background . ,title-image)
							 (foreground . ,font-colors)
							 (text . ,window-name)
							 (x-justify . center)
							 (y-justify . center)
							 (left-edge . 0)
							 (right-edge . 0)
							 (top-edge . -23)
							 (class . title)
							 )
							(
							 (background . ,top-image)
							 (left-edge . 0)
							 (right-edge . 0)
							 (top-edge . -26)
							 (class . top-border)
							 )
							(
							 (background . ,top-left-image)
							 (left-edge . -3)
							 (top-edge . -26)
							 (class . top-left-corner)
							 )
							(
							 (background . ,top-right-image)
							 (right-edge . -3)
							 (top-edge . -26)
							 (class . top-right-corner)
							 )
							(
							 (background . ,left-side-image)
							 (left-edge . -3)
							 (top-edge . 0)
							 (bottom-edge . 0)
							 (class . left-border)
							 )
							(
							 (background . ,right-side-image)
							 (right-edge . -3)
							 (top-edge . 0)
							 (bottom-edge . 0)
							 (class . right-border)
							 )
							(
							 (background . ,bottom-left-image)
							 (left-edge . -3)
							 (bottom-edge . -3)
							 (class . bottom-left-corner)
							 )
							(
							 (background . ,bottom-image)
							 (left-edge . 0)
							 (right-edge .0)
							 (bottom-edge . -3)
							 (class . bottom-border)
							 )
							(
							 (background . ,bottom-right-image)
							 (right-edge . -3)
							 (bottom-edge . -3)
							 (class . bottom-right-corner)
							 )
        
							(
							 (background . ,close-image)
							 (right-edge . 2)
							 (top-edge . ,button-top-offset)
							 (class . close-button)
							 )
							(
							 (background . ,max-image)
							 (right-edge . ,(+ (* 2 (button-side-offset) ) 32 ))
							 (top-edge . ,button-top-offset)
							 (class . maximize-button)
							 )
							(
							 (background . ,min-image)
							 (left-edge . ,(+ (* 2 (button-side-offset) ) 32 ))
							 (top-edge . ,button-top-offset)
							 (class . iconify-button)
							 )
							(
							 (background . ,menu-image)
							 (left-edge . 2)
							 (top-edge . ,button-top-offset)
							 (class . menu-button)
							 )
							)
						)
      
		 (shaped-frame `(
										 (
											(background . ,title-image)
											(foreground . ,font-colors)
											(text . ,window-name)
											(x-justify . center)
											(y-justify . center)
											(left-edge . 0)
											(right-edge . 0)
											(top-edge . -23)
											(class . title)
											)
										 (
											(background . ,top-image)
											(left-edge . 0)
											(right-edge . 0)
											(top-edge . -26)
											(class . title)
											)
										 (
											(background . ,top-left-image)
											(left-edge . -3)
											(top-edge . -26)
											(class . title)
											)
										 (
											(background . ,top-right-image)
											(right-edge . -3)
											(top-edge . -26)
											(class . title)
											)
										 (
											(background . ,bottom-left-image)
											(left-edge . -3)
											(top-edge . 0)
											(class . title)
											)
										 (
											(background . ,bottom-image)
											(left-edge . 0)
											(right-edge .0)
											(top-edge . 0)
											(class . title)
											)
										 (
											(background . ,bottom-right-image)
											(right-edge . -3)
											(top-edge . 0)
											(class . title)
											)
        
										 (
											(background . ,close-image)
											(right-edge . 2)
											(top-edge . ,button-top-offset)
											(class . close-button)
											)
										 (
											(background . ,max-image)
											(right-edge . ,(+ (* 2 (button-side-offset) ) 32 ))
											(top-edge . ,button-top-offset)
											(class . maximize-button)
											)
										 (
											(background . ,min-image)
											(left-edge . ,(+ (* 2 (button-side-offset) ) 32 ))
											(top-edge . ,button-top-offset)
											(class . iconify-button)
											)
										 (
											(background . ,menu-image)
											(left-edge . 2)
											(top-edge . ,button-top-offset)
											(class . menu-button)
											)
										 )
									 )
		 
		 (transient-frame `(
												(
												 (background . ,title-image)
												 (foreground . ,font-colors)
												 (text . ,window-name)
												 (x-justify . center)
												 (y-justify . center)
												 (left-edge . 0)
												 (right-edge . 0)
												 (top-edge . -23)
												 (class . title)
												 )
												(
												 (background . ,top-image)
												 (left-edge . 0)
												 (right-edge . 0)
												 (top-edge . -26)
												 (class . top-border)
												 )
												(
												 (background . ,top-left-image)
												 (left-edge . -3)
												 (top-edge . -26)
												 (class . top-left-corner)
												 )
												(
												 (background . ,top-right-image)
												 (right-edge . -3)
												 (top-edge . -26)
												 (class . top-right-corner)
												 )
												(
												 (background . ,left-side-image)
												 (left-edge . -3)
												 (top-edge . 0)
												 (bottom-edge . 0)
												 (class . left-border)
												 )
												(
												 (background . ,right-side-image)
												 (right-edge . -3)
												 (top-edge . 0)
												 (bottom-edge . 0)
												 (class . right-border)
												 )
												(
												 (background . ,bottom-left-image)
												 (left-edge . -3)
												 (bottom-edge . -3)
												 (class . bottom-left-corner)
												 )
												(
												 (background . ,bottom-image)
												 (left-edge . 0)
												 (right-edge .0)
												 (bottom-edge . -3)
												 (class . bottom-border)
												 )
												(
												 (background . ,bottom-right-image)
												 (right-edge . -3)
												 (bottom-edge . -3)
												 (class . bottom-right-corner)
												 )
        
												(
												 (background . ,close-image)
												 (right-edge . 2)
												 (top-edge . ,button-top-offset)
												 (class . close-button)
												 )
												(
												 (background . ,min-image)
												 (left-edge . 2)
												 (top-edge . ,button-top-offset)
												 (class . iconify-button)
												 )
												)
											)
		 
		 (shaped-transient-frame `(
															 (
																(background . ,title-image)
																(foreground . ,font-colors)
																(text . ,window-name)
																(x-justify . center)
																(y-justify . center)
																(left-edge . 0)
																(right-edge . 0)
																(top-edge . -23)
																(class . title)
																)
															 (
																(background . ,top-image)
																(left-edge . 0)
																(right-edge . 0)
																(top-edge . -26)
																(class . title)
																)
															 (
																(background . ,top-left-image)
																(left-edge . -3)
																(top-edge . -26)
																(class . title)
																)
															 (
																(background . ,top-right-image)
																(right-edge . -3)
																(top-edge . -26)
																(class . title)
																)
															 (
																(background . ,bottom-left-image)
																(left-edge . -3)
																(top-edge . 0)
																(class . title)
																)
															 (
																(background . ,bottom-image)
																(left-edge . 0)
																(right-edge .0)
																(top-edge . 0)
																(class . title)
																)
															 (
																(background . ,bottom-right-image)
																(right-edge . -3)
																(top-edge . 0)
																(class . title)
																)
        
															 (
																(background . ,close-image)
																(right-edge . 2)
																(top-edge . ,button-top-offset)
																(class . close-button)
																)
															 (
																(background . ,min-image)
																(left-edge . 2)
																(top-edge . ,button-top-offset)
																(class . iconify-button)
																)
															 )
														 )
		 
		 )
      
  (add-frame-style 'sawzilla
									 (lambda (w type)
										 (cond 
											((eq type 'transient) transient-frame)
											((eq type 'shaped-transient) shaped-transient-frame)
											((eq type 'shaped) shaped-frame)
											((eq type 'unframed) nil-frame)
											(t frame))))            
	)
